# Instumental Variable Models for Discrete Outcomes, Andrew Chesher, November 2nd 2009.

# Calculation of identified sets in the binary Y and binary X case.

# This file reproduces figures 1 and 2 of the paper as well as graphs for supplementary materials.
# ---------------------------------------------------------------------------------
rm(list=ls())
source("./Libs/binlib.R")		# load the library 

sv <- FALSE		# if true then save figures


# Here is the z sequence used in the paper.
# -0.7500 -0.5625 -0.3750 -0.1875  0.0000  0.1875  0.3750  0.5625  0.7500

# Graphs for Paper Figure 1 - here in colour not in grey scale

if(sv) pdf("./Graphs/figure1a.pdf",width=6,heigh=6)
	drawbounds5(c(0),a1=0.5,rho=-0.25,intersect=F,fill=T,writetext="z = 0")
if(sv) dev.off()

if(sv) pdf("./Graphs/figure1b.pdf",width=6,heigh=6)
	drawbounds5(c(0.75),a1=0.5,rho=-0.25,intersect=F,fill=T,writetext="z = 0.75")
if(sv) dev.off()

if(sv) pdf("./Graphs/figure1c.pdf",width=6,heigh=6)	
	drawbounds5(c(-0.75),a1=0.5,rho=-0.25,intersect=F,fill=T,writetext="z = -0.75")
if(sv) dev.off()

if(sv) pdf("./Graphs/figure1d.pdf",width=6,heigh=6)
	drawbounds5(c(-0.75,0,.75),a1=0.5,rho=-0.25,intersect=T,fill=T,writetext="")
if(sv) dev.off()

# Graphs for Paper Figure 2 - here in colour not in grey scale

if(sv) pdf("./Graphs/figure2a.pdf",width=6,heigh=6)
	drawbounds5(c(0),a1=0.5,rho=-0.25,b1=0.3,intersect=F,fill=T,writetext="z = 0")
if(sv) dev.off()

if(sv) pdf("./Graphs/figure2b.pdf",width=6,heigh=6)
	drawbounds5(c(0.75),a1=0.5,rho=-0.25,b1=0.3,intersect=F,fill=T,writetext="z = 0.75")
if(sv) dev.off()

if(sv) pdf("./Graphs/figure2c.pdf",width=6,heigh=6)
	drawbounds5(c(-0.75),a1=0.5,rho=-0.25,b1=0.3,intersect=F,fill=T,writetext="z = -0.75")
if(sv) dev.off()

if(sv) pdf("./Graphs/figure2d.pdf",width=6,heigh=6)
	drawbounds5(c(-0.75,0,.75),a1=0.5,rho=-0.25,b1=0.3,intersect=T,fill=T,writetext="")
if(sv) dev.off()

# ---------------------------------------------------------------------------------
# Graphs for Supplementary Material

# Fig 1
if(sv) pdf("./Graphs/supFig01.pdf",width=6,heigh=6)
drawbounds5(c(-0.75),a1=0.5,rho=-0.25,intersect=F,fill=T,writetext="z = -0.75")
if(sv) dev.off()

# Fig 2
if(sv) pdf("./Graphs/supFig02.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625),a1=0.5,rho=-0.25,intersect=F,fill=T,writetext="z = -0.5625")
if(sv) dev.off()

# Fig 3
if(sv) pdf("./Graphs/supFig03.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375),a1=0.5,rho=-0.25,intersect=T,fill=T,writetext="z = -0.375")
if(sv) dev.off()

# Fig 4
if(sv) pdf("./Graphs/supFig04.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875),a1=0.5,rho=-0.25,intersect=T,fill=T,writetext="z = -0.1875")
if(sv) dev.off()

# Fig 5
if(sv) pdf("./Graphs/supFig05.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875, 0.0000),a1=0.5,rho=-0.25,intersect=T,fill=T,writetext="z = 0")
if(sv) dev.off()

# Fig 6
if(sv) pdf("./Graphs/supFig06.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875, 0.0000 , 0.1875),a1=0.5,rho=-0.25,intersect=T,fill=T,writetext="z = +0.1875")
if(sv) dev.off()

# Fig 7
if(sv) pdf("./Graphs/supFig07.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875, 0.0000 , 0.1875, .375),a1=0.5,rho=-0.25,intersect=T,fill=T,writetext="z = +0.375")
if(sv) dev.off()

# Fig 8
if(sv) pdf("./Graphs/supFig08.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875, 0.0000 , 0.1875, .375, .5625),a1=0.5,rho=-0.25,intersect=T,fill=T,writetext="z = +0.5625")
if(sv) dev.off()

# Fig 9
if(sv) pdf("./Graphs/supFig09.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875, 0.0000 , 0.1875, .375, .5625, .75),a1=0.5,rho=-0.25,intersect=T,fill=T,writetext="z = +0.75")
if(sv) dev.off()

# Fig 10
if(sv) pdf("./Graphs/supFig10.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875, 0.0000 , 0.1875, .375, .5625, .75),a1=0.5,rho=0.0,intersect=T,fill=T,writetext="r = 0")
if(sv) dev.off()

# Fig 11
if(sv) pdf("./Graphs/supFig11.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875, 0.0000 , 0.1875, .375, .5625, .75),a1=0.5,rho=0.25,intersect=T,fill=T,writetext="r = +0.25")
if(sv) dev.off()

# Fig 12
if(sv) pdf("./Graphs/supFig12.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875, 0.0000 , 0.1875, .375, .5625, .75),a1=0.5,rho=0.50,intersect=T,fill=T,writetext="r = +0.5")
if(sv) dev.off()

# Fig 13
if(sv) pdf("./Graphs/supFig13.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875, 0.0000 , 0.1875, .375, .5625, .75),a1=0.5,b1=0.3,rho=0.50,intersect=T,
     fill=T,writetext=expression(paste(b[1]," = 0.3")))
if(sv) dev.off()

# Fig 14
if(sv) pdf("./Graphs/supFig14.pdf",width=6,heigh=6)
drawbounds5(c(-0.75, -.5625, -.375, -.1875, 0.0000 , 0.1875, .375, .5625, .75),a1=0.5,b1=2,rho=0.50,intersect=T,fill=T,
     writetext=expression(paste(b[1]," = 2.0")))
if(sv) dev.off()

#end of programme.
