# Instumental Variable Models for Discrete Outcomes, Andrew Chesher, November 2nd 2009.

# this file reproduces figures 3 and 4 of the paper.
# --------------------------------------------------------------------------
# load results and plot figures
rm(list=ls())
source("./Libs/adclib.R")		# load the library 
source("./Libs/radarlib.R")		# load the library 

# load results (to reproduce results run script resOrdPrb.R )
load(file="./Data/ivmdoOrdPrb.Rdata")

sv <- FALSE		# if true then save figures 
colins <- c("white","white","grey70","grey40") # define colours of the sets



# --- paper: Figure 3

if(sv) pdf("./Graphs/figure3.pdf",width=6,heigh=6)


	plotRadar(list(res5w,res5s),xlim=c(-1,1),ylim=c(0,2.5),colin=colins[3:4])

	abline(v=0,lty=2)						# 'true' alpha[0]
	abline(h=1,lty=2)						# 'true' alpha[1]
	points(0,1,pch=19,cex=1.6,col="black")	# "true"

	legend(-1, 2.5, c("weak instrument", "strong instrument"), col = colins[3:4],
       	text.col = "black",lty=0,lwd=3, pch = 22,pt.bg=colins[3:4],merge = TRUE)

if(sv) dev.off()




# --- paper: Figure 4

if(sv) pdf("./Graphs/figure4.pdf",width=6,heigh=6)

	plotRadar(list(res5w,res5s,res11w,res11s),xlim=c(-1,1),ylim=c(0,2.5),colin=colins)

	abline(v=0,lty=2)						# 'true' alpha[0]
	abline(h=1,lty=2)						# 'true' alpha[1]
	points(0,1,pch=19,cex=1.6,col="black")	# "true"


	legend(-1, 2.5, c("weak instrument", "strong instrument"), col = colins[3:4],
       	text.col = "black",lty=0,lwd=3, pch = 22,pt.bg=colins[3:4],merge = TRUE)

if(sv) dev.off()
